﻿--[[----------------------------------------------------------------------
      WarnFrame Module - Part of VanasKoS
Creates the WarnFrame to alert of nearby KoS, Hostile and Friendly
------------------------------------------------------------------------]]
local nearbyKos = { };
local nearbyEnemys = { };
local nearbyFriendly = { };
local lookupList = { };

local L = AceLibrary("AceLocale-2.2"):new("VanasKoSWarnFrame");
VanasKoSWarnFrame = VanasKoS:NewModule("WarnFrame");

local NOTIFYTIMERINTERVAL = 60;

L:RegisterTranslations("enUS", function() return {
	["Content"] = true,
	["What to show in it"] = true,
	["Design"] = true,
	["How the content is shown"] = true,
	
	["Show Target Level When Possible"] = true,
	["Show KoS Targets"] = true,
	["Show Hostile Targets"] = true,
	["Show Friendly Targets"] = true,
	
	["Default Background Color"] = true,
	["Sets the default Background Color and Opacity"] = true,
	
	["More Hostiles than Allied Background Color"] = true,
	["Sets the more Hostiles than Allied Background Color and Opacity"] = true,
	
	["More Allied than Hostiles Background Color"] = true,
	["Sets the more Allied than Hostiles Background Color and Opacity"] = true,

	["Reset Background Colors"] = true,
	["Resets all Background Colors to default Settings"] = true,
	["Show additional Informations on Mouse Over"] = true,
	["Toggles the display of additional Informations on Mouse Over"] = true,
	
	["Configuration"] = true,
	["KoS/Enemy/Friendly Warning Window"] = true,
	["Hide if inactive"] = true,
	["Enabled"] = true,
	["Locked"] = true,
	["Reset Position"] = true,

	["Level"] = true,
	["No Information Available"] = true,
	
	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );
	
L:RegisterTranslations("deDE", function() return {
	["Content"] = "Inhalt",
	["What to show in it"] = "Was angezeigt wird",
	["Design"] = "Aussehen",
	["How the content is shown"] = "Aussehen der anzeigten Daten",

	["Show Target Level When Possible"] = "Level von Zielen anzeigen (wenn möglich)",
	["Show KoS Targets"] = "KoS-Ziele anzeigen",
	["Show Hostile Targets"] = "Feindliche Ziele anzeigen",
	["Show Friendly Targets"] = "Freundliche Ziele anzeigen",
	
	["Default Background Color"] = "Standard Hintergrundfarbe",
	["Sets the default Background Color and Opacity"] = "Setzt die standardmaessige Hintergrundfarbe und Transparenz",
	
	["More Hostiles than Allied Background Color"] = "Mehr Feinde als Verbuendete Hintergrundfarbe",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "Setzt die Hintergrundfarbe und Transparenz wenn mehr Feinde als Verbuendete da sind",
	
	["More Allied than Hostiles Background Color"] = "Mehr Verbuendete als Feinde Hintergrundfarbe",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "Setzt die Hintergrundfarbe und Transparenz wenn mehr Verbuendete als Feinde da sind",
	
	["Reset Background Colors"] = "Hintergrundfarben zuruecksetzen",
	["Resets all Background Colors to default Settings"] = "Alle Hintergrundfarben auf ihre Standardwerte zuruecksetzen",

	["Show additional Informations on Mouse Over"] = "Zusätzliche Informationen bei Maus überfahrt",
	["Toggles the display of additional Informations on Mouse Over"] = "Zusätzliche Informationen beim herüberfahren mit der Maus anzeigen",

	["Configuration"] = "Konfiguration",
	["KoS/Enemy/Friendly Warning Window"] = "KoS/Feind/Freund Warn-Fenster",
	["Hide if inactive"] = "Verstecken wenn inaktiv",
	["Enabled"] = "Aktiviert",
	["Locked"] = "Sperren",
	["Reset Position"] = "Position zurücksetzen",

	["Level"] = "Level",
	["No Information Available"] = "No Information Available",

	["_Unknown Entity_"] = UNKNOWN,
} end );

L:RegisterTranslations("frFR", function() return {
	["Content"] = "Contenu",
	["What to show in it"] = "Ce que vous voulez afficher",
	["Design"] = "Apparence",
	["How the content is shown"] = "Comment l'apparence est affich\195\169",

	["Show Target Level When Possible"] = "Afficher le level des cibles quand c'est possible",
	["Show KoS Targets"] = "Afficher cibles KoS",
	["Show Hostile Targets"] = "Afficher cibles hostiles",
	["Show Friendly Targets"] = "Afficher cibles amis",

	["Default Background Color"] = "Couleur de fond",
	["Sets the default Background Color and Opacity"] = "Choisir la couleur et l'opacit\195\169",

	["More Hostiles than Allied Background Color"] = "Couleur de fond pour cible hostile",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "Choisir la couleur de fond pour cible hostile",

	["More Allied than Hostiles Background Color"] = "Couleur de fond pour cible amical",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "Choisir la couleur de fond pour cible amical",

	["Reset Background Colors"] = "Remettre par d\195\169faut",
	["Resets all Background Colors to default Settings"] = "Remet par d\195\169faut la couleur de fond et l'opacit\195\169",

--	["Show additional Informations on Mouse Over"] = true,
--	["Toggles the display of additional Informations on Mouse Over"] = true,

	["Configuration"] = "Configuration",
	["KoS/Enemy/Friendly Warning Window"] = "Fen\195\170tre d'avertissement KoS/Ennemi/Amis",
	["Hide if inactive"] = "Cacher si inactif",
	["Enabled"] = "Actif",
	["Locked"] = "Verrouill\195\169",
	["Reset Position"] = "Remettre à zéro la position",
	
	["Level"] = "Level",
	["No Information Available"] = "No Information Available",

	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );

L:RegisterTranslations("koKR", function() return {
	["Content"] = "내용",
	["What to show in it"] = "표시 내용",
	["Design"] = "디자인",
	["How the content is shown"] = "표시 방법",
	
	["Show Target Level When Possible"] = "대상의 레벨 표시",
	["Show KoS Targets"] = "KoS 대상 표시",
	["Show Hostile Targets"] = "적대적 대상 표시",
	["Show Friendly Targets"] = "우호적 대상 표시",
	
	["Default Background Color"] = "기본 배경 색상",
	["Sets the default Background Color and Opacity"] = "기본 배경의 색상과 투명도를 설정합니다.",
	
	["More Hostiles than Allied Background Color"] = "적대적 배경 색상",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "적대적 배경 색상과 투명도를 설정합니다.",
	
	["More Allied than Hostiles Background Color"] = "우호적 배경 색상",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "우호적 배경 색상과 투명도를 설정합니다.",

	["Reset Background Colors"] = "배경 색상 초기화",
	["Resets all Background Colors to default Settings"] = "모든 배경 색상을 기본 설정으로 초기화합니다.",

--	["Show additional Informations on Mouse Over"] = true,
--	["Toggles the display of additional Informations on Mouse Over"] = true,
	
	["Configuration"] = "환경설정",
	["KoS/Enemy/Friendly Warning Window"] = "KoS/적대적/우호적 알림창",
	["Hide if inactive"] = "사용하지 않으면 숨김",
	["Enabled"] = "사용",
	["Locked"] = "고정",
	["Reset Position"] = "위치 초기화",

	["Level"] = "Level",
	["No Information Available"] = "No Information Available",

	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );

L:RegisterTranslations("esES", function() return {
	["Content"] = "Contenido",
	["What to show in it"] = "Qué mostrar en él",
	["Design"] = "Diseño",
	["How the content is shown"] = "Cómo se muestra el contenido",
	
	["Show Target Level When Possible"] = "Mostrar el nivel del objetivo cuando sea posible",
	["Show KoS Targets"] = "Mostrar objetivos KoS",
	["Show Hostile Targets"] = "Mostrar objetivos hostiles",
	["Show Friendly Targets"] = "Mostrar objetivos amistosos",
	
	["Default Background Color"] = "Color de fondo por defecto",
	["Sets the default Background Color and Opacity"] = "Establece el color de fondo y la opacidad por defecto",
	
	["More Hostiles than Allied Background Color"] = "Color de fondo de más hostiles que aliados",
	["Sets the more Hostiles than Allied Background Color and Opacity"] = "Establece el color de fondo y la opacidad de más hostiles que aliados",
	
	["More Allied than Hostiles Background Color"] = "Color de fondo de más aliados que hostiles",
	["Sets the more Allied than Hostiles Background Color and Opacity"] = "Establece el color de fondo y la opacidad de más aliados que hostiles",          

	["Reset Background Colors"] = "Reestablecer Colores de Fondo",
	["Resets all Background Colors to default Settings"] = "Reestablece todos los colores de fondo a los ajustes por defecto",
	
	["Configuration"] = "Configuración",
	["KoS/Enemy/Friendly Warning Window"] = "Ventana de Aviso de KoS/Enemigo/Amistoso",
	["Hide if inactive"] = "Ocultar si inactivo",
	["Enabled"] = "Activado",
	["Locked"] = "Bloqueado",
	["Reset Position"] = "Reestablecer Posición",

	["Level"] = "Nivel",
	
	-- the text that appears in the combat log when the name of the target isn't known
	["_Unknown Entity_"] = UNKNOWN,
} end );

local dewdrop = AceLibrary("Dewdrop-2.0");

function VanasKoSWarnFrame:OnInitialize()

	self.WARN_FRAME_WIDTH = 130;
	self.WARN_FRAME_HEIGHT = 91;
	self.WARN_BUTTON_HEIGHT = 16;
	self.WARN_TOOLTIP_WIDTH = 400;
	self.WARN_TOOLTIP_HEIGHT = 24;

	VanasKoS:RegisterDefaults("WarnFrame", "profile", {
		Enabled = true,
		HideIfInactive = false,
		Locked = false,

		ShowTargetLevel = true,
		ShowKoS = true,
		ShowHostile = true,
		ShowFriendly = true,
		ShowMouseOverInfos = true,
		
		DefaultBGColorR = 0.5,
		DefaultBGColorG = 0.5,
		DefaultBGColorB = 1.0,
		DefaultBGColorA = 0.5,
		
		MoreHostileBGColorR = 1.0,
		MoreHostileBGColorG = 0.0,
		MoreHostileBGColorB = 0.0,
		MoreHostileBGColorA = 0.5,
		
		MoreAlliedBGColorR = 0.0,
		MoreAlliedBGColorG = 1.0,
		MoreAlliedBGColorB = 0.0,
		MoreAlliedBGColorA = 0.5,
	});

	self.db = VanasKoS:AcquireDBNamespace("WarnFrame");
	self.warnButtonModel = {}
	local r, g, b, a = self:GetColor("DefaultBGColor");

	-- Create the warning frame's tooltip.
	self.warnTooltip = CreateFrame("Button", "WarnTooltip", UIParent);
	local warnTooltip = self.warnTooltip;
	warnTooltip:SetWidth(self.WARN_TOOLTIP_WIDTH);
	warnTooltip:SetHeight(self.WARN_TOOLTIP_HEIGHT);
	warnTooltip:SetPoint("CENTER");
	warnTooltip:SetToplevel(true);
	warnTooltip:SetMovable(true);
	warnTooltip:SetFrameStrata("LOW");
	warnTooltip:EnableMouse(false);
	warnTooltip:SetBackdrop( {
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 5, right = 4, top = 5, bottom = 5 }
	});
	warnTooltip:SetBackdropColor(r, g, b, a);
	warnTooltip:SetTextFontObject(GameFontNormal);
	warnTooltip:SetTextColor(1.0, 1.0, 1.0);
	warnTooltip:SetText("This is a test...");
	warnTooltip:Hide();
	
	-- Create the warning frame.
	local name = "VanasKoS_WarnFrame";
	self.frame = CreateFrame("Button", name, UIParent);
	local frame = self.frame;
	self.warnDetailsCache = {}
	
	frame:SetWidth(self.WARN_FRAME_WIDTH);
	frame:SetHeight(self.WARN_FRAME_HEIGHT);
	frame:SetPoint("CENTER");
	frame:SetToplevel(true);
	frame:SetMovable(true);
	frame:SetFrameStrata("LOW");
	frame:EnableMouse(true);
	frame:SetBackdrop( {
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 5, right = 4, top = 5, bottom = 5 }
		});
	
	frame:SetBackdropColor(r, g, b, a);
	
	frame:RegisterForDrag("LeftButton");

	frame:RegisterForClicks("RightButtonUp", "LeftButtonUp");
	frame:SetScript("OnClick", function()
									if(arg1 == "RightButton") then
										dewdrop:Open(VanasKoSWarnFrame.frame);
									end
								end);
	frame:SetScript("OnDragStart",
								function()
									if(VanasKoSWarnFrame.db.profile.Locked) then
										return;
									end
									frame:StartMoving();
								end);
	frame:SetScript("OnDragStop",
								function()
									frame:StopMovingOrSizing();
								end);
	frame:SetScript("OnLeave", function()
										self:HideWarnTooltip();
									end);
	for i=0,4,1 do
		local warnButton = CreateFrame("Button", name .. "Text" .. i, frame);
		if(i == 0) then
			warnButton:SetPoint("TOP", frame, 0, -5);
		else
			warnButton:SetPoint("TOP", "VanasKoS_WarnFrameText" .. (i - 1), "BOTTOM", 0, 0);
		end
		warnButton:SetToplevel(true);
		warnButton:SetMovable(false);
		warnButton:EnableMouse(false);
		warnButton:SetWidth(self.WARN_FRAME_WIDTH);
		warnButton:SetHeight(self.WARN_BUTTON_HEIGHT);
		warnButton:SetTextFontObject(GameFontNormal);
		warnButton:RegisterForClicks("LeftButtonUp");
		warnButton:SetScript("OnClick", function()
											self:AddEntry(i);
										end);
		warnButton:SetScript("OnEnter", function()
											self:ShowWarnTooltip(i);
										end);
		warnButton:Show();
	end
	
	local configOptions = {
		type = 'group',
		name = L["Configuration"],
		desc = L["Configuration"],
		args = {
			title = {
				type = 'header',
				name = L["Configuration"],
				order = 1,
			},
			content = {
				type = 'group',
				name = L["Content"],
				desc = L["What to show in it"],
				order = 2,
				args = {
					showLevel = {
						type = 'toggle',
						name = L["Show Target Level When Possible"],
						desc = L["Show Target Level When Possible"],
						order = 1,
						get = function() return VanasKoSWarnFrame.db.profile.ShowTargetLevel; end,
						set = function(v) VanasKoSWarnFrame.db.profile.ShowTargetLevel = v; VanasKoSWarnFrame:Update(); end
					},
					showKoS = {
						type = 'toggle',
						name = L["Show KoS Targets"],
						desc = L["Show KoS Targets"],
						order = 2,
						get = function() return VanasKoSWarnFrame.db.profile.ShowKoS; end,
						set = function(v) VanasKoSWarnFrame.db.profile.ShowKoS = v; VanasKoSWarnFrame:Update(); end
					},
					showHostile = {
						type = 'toggle',
						name = L["Show Hostile Targets"],
						desc = L["Show Hostile Targets"],
						order = 3,
						get = function() return VanasKoSWarnFrame.db.profile.ShowHostile; end,
						set = function(v) VanasKoSWarnFrame.db.profile.ShowHostile = v; VanasKoSWarnFrame:Update(); end
					},
					showFriendly = {
						type = 'toggle',
						name = L["Show Friendly Targets"],
						desc = L["Show Friendly Targets"],
						order = 4,
						get = function() return VanasKoSWarnFrame.db.profile.ShowFriendly; end,
						set = function(v) VanasKoSWarnFrame.db.profile.ShowFriendly = v; VanasKoSWarnFrame:Update(); end
					},
					showMouseOverInfos = {
						type = 'toggle',
						name = L["Show additional Informations on Mouse Over"],
						desc = L["Toggles the display of additional Informations on Mouse Over"],
						order = 5,
						get = function() return VanasKoSWarnFrame.db.profile.ShowMouseOverInfos; end,
						set = function(v) VanasKoSWarnFrame.db.profile.ShowMouseOverInfos = v; VanasKoSWarnFrame:Update(); end
					},
				}
			},
			design = {
				type = 'group',
				name = L["Design"],
				desc = L["How the content is shown"],
				order = 3,
				args = {
					defaultBackdropBackgroundColor = {
						type = 'color',
						name = L["Default Background Color"],
						desc = L["Sets the default Background Color and Opacity"],
						order = 1,
						get = function() return VanasKoSWarnFrame:GetColor("DefaultBGColor") end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("DefaultBGColor", r, g, b, a); end,
						hasAlpha = true,
					},
					moreHostilesBackdropBackgroundColor = {
						type = 'color',
						name = L["More Hostiles than Allied Background Color"],
						desc = L["Sets the more Hostiles than Allied Background Color and Opacity"],
						order = 2,
						get = function() return VanasKoSWarnFrame:GetColor("MoreHostileBGColor"); end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("MoreHostileBGColor", r, g, b, a); end,
						hasAlpha = true
					},
					moreAlliedBackdropBackgroundColor = {
						type = 'color',
						name = L["More Allied than Hostiles Background Color"],
						desc = L["Sets the more Allied than Hostiles Background Color and Opacity"],
						order = 3,
						get = function() return VanasKoSWarnFrame:GetColor("MoreAlliedBGColor"); end,
						set = function(r, g, b, a) VanasKoSWarnFrame:SetColor("MoreAlliedBGColor", r, g, b, a); end,
						hasAlpha = true
					},
					resetBackgroundColors = {
						type = 'execute',
						name = L["Reset Background Colors"],
						desc = L["Resets all Background Colors to default Settings"],
						order = 4,
						func = function() 
									VanasKoSWarnFrame:SetColor("MoreHostileBGColor", 1.0, 0.0, 0.0, 0.5);
									VanasKoSWarnFrame:SetColor("MoreAlliedBGColor", 0.0, 1.0, 0.0, 0.5);
									VanasKoSWarnFrame:SetColor("DefaultBGColor", 0.5, 0.5, 1.0, 0.5);
								end,
					},
				}
			},
			enabled = {
				type = 'toggle',
				name = L["Enabled"],
				desc = L["Enabled"],
				order = 4,
				set = function(v) VanasKoSWarnFrame.db.profile.Enabled = v; VanasKoS:ToggleModuleActive("WarnFrame", VanasKoSWarnFrame.db.profile.Enabled); VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoSWarnFrame.db.profile.Enabled; end,
			},
			locked = {
				type = 'toggle',
				name = L["Locked"],
				desc = L["Locked"],
				order = 5,
				set = function(v) VanasKoSWarnFrame.db.profile.Locked = v; end,
				get = function() return VanasKoSWarnFrame.db.profile.Locked; end,
			},
			hideifinactive = {
				type = 'toggle',
				name = L["Hide if inactive"],
				desc = L["Hide if inactive"],
				order = 6,
				set = function(v) VanasKoSWarnFrame.db.profile.HideIfInactive = v; VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoSWarnFrame.db.profile.HideIfInactive; end,
			},
			reset = {
				type = 'execute',
				name = L["Reset Position"],
				desc= L["Reset Position"],
				order = 7,
				func = function() VanasKoS_WarnFrame:ClearAllPoints(); VanasKoS_WarnFrame:SetPoint("CENTER"); end,
			}
			
		}
	}
	dewdrop:Register(frame,
				'children', configOptions
				);
				
	VanasKoSGUI:AddConfigOption("WarnFrame", {
		type = 'group',
		name = L["KoS/Enemy/Friendly Warning Window"],
		desc = L["KoS/Enemy/Friendly Warning Window"],
		args = {
			enabled = {
				type = 'toggle',
				name = L["Enabled"],
				desc = L["Enabled"],
				order = 1,
				set = function(v) VanasKoSWarnFrame.db.profile.Enabled = v; VanasKoS:ToggleModuleActive("WarnFrame", VanasKoSWarnFrame.db.profile.Enabled); VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoSWarnFrame.db.profile.Enabled; end,
			},
			locked = {
				type = 'toggle',
				name = L["Locked"],
				desc = L["Locked"],
				order = 2,
				set = function(v) VanasKoSWarnFrame.db.profile.Locked = v; end,
				get = function() return VanasKoSWarnFrame.db.profile.Locked; end,
			},
			hideifinactive = {
				type = 'toggle',
				name = L["Hide if inactive"],
				desc = L["Hide if inactive"],
				order = 3,
				set = function(v) VanasKoSWarnFrame.db.profile.HideIfInactive = v; VanasKoSWarnFrame:Update(); end,
				get = function() return VanasKoSWarnFrame.db.profile.HideIfInactive; end,
			},
			reset = {
				type = 'execute',
				name = L["Reset Position"],
				desc= L["Reset Position"],
				func = function() VanasKoS_WarnFrame:ClearAllPoints(); VanasKoS_WarnFrame:SetPoint("CENTER"); end,
			}
		}
	});

	frame:Hide();
	self:Update();
end

function VanasKoSWarnFrame:OnEnable()
	NOTIFYTIMERINTERVAL = VanasKoSNotifier.db.profile.NotifyTimerInterval;
	self:RegisterEvent("VanasKoS_Player_Detected", "AddPlayer");
	self:Update();
end

function VanasKoSWarnFrame:OnDisable()
	self:UnregisterAllEvents();
	self:CancelAllScheduledEvents();
	nearbyKos = { };
	nearbyEnemys = { };
	nearbyFriendly = { };
	lookupList = { };
	self.frame:Hide();
end

function VanasKoSWarnFrame:GetColor(which)
	return self.db.profile[which .. "R"], self.db.profile[which .. "G"], self.db.profile[which .. "B"], self.db.profile[which .. "A"];
end

function VanasKoSWarnFrame:SetColor(which, r, g, b, a)
	VanasKoSWarnFrame.frame:SetBackdropColor(r, g, b, a)
	
	self.db.profile[which .. "R"] = r;
	self.db.profile[which .. "G"] = g;
	self.db.profile[which .. "B"] = b;
	self.db.profile[which .. "A"] = a;
end

function VanasKoSWarnFrame:AddEntry(index)
	local arr = self.warnButtonModel[index];
	if (arr ~= nil) then
		local name = arr[1];
		VanasKoS:AddEntryByName("PLAYERKOS", name);
	end
end

function VanasKoSWarnFrame:ShowWarnTooltip(index)
	if(not self.db.profile.ShowMouseOverInfos) then
		if(self.warnTooltip:IsVisible()) then
			self.warnTooltip:Hide();
		end
		return;
	end
	if (self.warnButtonModel[index] ~= nil) then
		local text = self:GetTooltipFormat(self.warnButtonModel[index]);
		if (text ~= nil and text ~= "") then
			self.warnTooltip:SetText(text);
			local x, y = GetCursorPosition();
			local scale = UIParent:GetEffectiveScale();
			x = x + 10;
			self.warnTooltip:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", x/scale, y/scale);
			self.warnTooltip:Show();
		else
			self.warnTooltip:Hide();
		end
	else
		self.warnTooltip:Hide();
	end
end

function VanasKoSWarnFrame:HideWarnTooltip()
	self.warnTooltip:Hide();
end

function VanasKoSWarnFrame:RemovePlayer(name)
	for k,v in pairs(nearbyKos) do
		if(v[1] == name) then
			tremove(nearbyKos, k);
		end
	end
	for k,v in pairs(nearbyEnemys) do
		if(v[1] == name) then
			tremove(nearbyEnemys, k);
		end
	end
	for k,v in pairs(nearbyFriendly) do
		if(v[1] == name) then
			tremove(nearbyFriendly, k);
		end
	end

	lookupList[name] = nil;
	
	self:Update();
end

function VanasKoSWarnFrame:AddPlayer(name, guild, faction, data)
	if(name == nil) then
		return;
	end

	if(name == L["_Unknown Entity_"]) then
		return nil;
	end

	name = string.trim(name);

	if(faction == "kos") then
		if(lookupList[name] == nil) then
			lookupList[name] = true;
			tinsert(nearbyKos, { name, faction, data });
		end
		self:CancelScheduledEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, self, name);
		self:ScheduleEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, NOTIFYTIMERINTERVAL, self, name);
		VanasKoSWarnFrame:Update();

		return nil;
	end
	if(faction == "enemy") then
		if(lookupList[name] == nil) then
			tinsert(nearbyEnemys, { name, faction, data });
		end
	end
	if(faction == "friendly") then
		if(lookupList[name] == nil) then
			tinsert(nearbyFriendly, { name, faction, data });
		end
	end

	if(lookupList[name] == nil) then
		self:CancelScheduledEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, self, name);
		self:ScheduleEvent("VanasKoSWarnFrameRemovePlayer_" .. name, self.RemovePlayer, 10, self, name);
		
		lookupList[name] = true;
		self:Update();
	end
end

function VanasKoSWarnFrame:DebugShowTables()
	self:Print("showtables");
	-- kos
	for k, v in pairs(nearbyKos) do
		self:Print(v[1]);
	end

	-- enemy but not kos
	for k, v in pairs(nearbyEnemys) do
		self:Print(v[1]);
	end

	-- friendly players
	for k, v in pairs(nearbyFriendly) do
		self:Print(v[1]);
	end
end

function VanasKoSWarnFrame:Update()
	NOTIFYTIMERINTERVAL = VanasKoSNotifier.db.profile.NotifyTimerInterval;
	-- +1, because it doesn't count you
	-- more hostile
	if( (#nearbyKos+#nearbyEnemys) > (#nearbyFriendly+1)) then
		local r, g, b, a = self:GetColor("MoreHostileBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end
	-- more allied
	if( (#nearbyKos+#nearbyEnemys) < (#nearbyFriendly+1)) then
		local r, g, b, a = self:GetColor("MoreAlliedBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end
	-- default
	if( ((#nearbyKos+#nearbyEnemys) == 0) or ((#nearbyKos+#nearbyEnemys) == (#nearbyFriendly+1)) ) then
		local r, g, b, a = self:GetColor("DefaultBGColor");
		VanasKoS_WarnFrame:SetBackdropColor(r, g, b, a);
	end

	local counter = 0;
	self.warnButtonModel = {};

	-- kos
	if(self.db.profile.ShowKoS) then
		for k, v in pairs(nearbyKos) do
			if (counter < 5) then
				local entry = getglobal("VanasKoS_WarnFrameText" .. counter);
				entry:SetTextColor(1.0, 0.0, 1.0);
				entry:SetText(self:GetWarnFormat(v));
				entry:EnableMouse(true);
				self.warnButtonModel[counter] = v
				counter = counter + 1;
			end
		end
	end
	
	-- enemy but not kos
	if(self.db.profile.ShowHostile) then
		for k, v in pairs(nearbyEnemys) do
			if (counter < 5) then
				local entry = getglobal("VanasKoS_WarnFrameText" .. counter);
				entry:SetTextColor(1.0, 0.0, 0.0);
				entry:SetText(self:GetWarnFormat(v));
				entry:EnableMouse(true);
				self.warnButtonModel[counter] = v
				counter = counter + 1;
			end
		end
	end
	
	-- friendly players
	if(self.db.profile.ShowFriendly) then
		for k, v in pairs(nearbyFriendly) do
			if (counter < 5) then
				local entry = getglobal("VanasKoS_WarnFrameText" .. counter);
				entry:SetTextColor(0.0, 1.0, 0.0);
				entry:SetText(self:GetWarnFormat(v));
				entry:EnableMouse(true);
				self.warnButtonModel[counter] = v
				counter = counter + 1;
			end
		end
	end
	
	if(counter < 5) then
		for i=counter, 5, 1 do
			local entry = getglobal("VanasKoS_WarnFrameText" .. counter);
			entry:SetText("");
			entry:EnableMouse(false);
		end
	end

	if(self.db.profile.Enabled) then
		if(self.db.profile.HideIfInactive) then
			if(counter > 0) then
				if(not self.frame:IsVisible()) then
					UIFrameFadeIn(self.frame, 0.1, 0.0, 1.0);
					self.frame:Show();
				end
			else
				if(self.frame:IsVisible()) then
					UIFrameFadeOut(self.frame, 0.1, 1.0, 0.0);
					self.frame.fadeInfo.finishedFunc = function() VanasKoS_WarnFrame:Hide(); end;
				end
			end
		else
			if(not self.frame:IsVisible()) then
				UIFrameFadeIn(self.frame, 0.1, 0.0, 1.0);
				self.frame:Show();
			end
		end
	else
		self.frame:Hide();
	end
end

function VanasKoSWarnFrame:GetWarnFormat(arr)
	local result = arr[1];	-- arr[1] is name

	-- Create a cache entry.
	if(self.warnDetailsCache[result] == nil) then
		self.warnDetailsCache[result] = { };
	end
	if(self.db.profile.ShowTargetLevel) then

		local level = nil;

		-- If there is a player level coming in, record it.
		if (arr[3] ~= nil and arr[3].level ~= nil and arr[3].level ~= "") then	-- arr[3] is a dao.
			level = arr[3].level;
			if (tonumber(level) == -1) then
				level = "??";
			end
			self.warnDetailsCache[result].level = level;

		-- If there is no level coming in, attempt a cache lookup.
		else
			level = self.warnDetailsCache[result].level;
		end

		-- If we have a level, append it.
		if (level ~= nil) then
			result = result .. " [" .. tostring(level) .. "]";
		end

	end

	return result;
end

function VanasKoSWarnFrame:GetTooltipFormat(arr)

	local showDetails = true;
	local dao = arr[3];

	if (dao == nil) then
		showDetails = false;
	end
	
	local result = "";
	local name = arr[1];

	if (showDetails) then

		if (dao.level ~= nil) then
			result = result .. L["Level"] .. " " .. dao.level .. " ";
		end
	
		if (dao.class ~= nil) then
			result = result .. dao.class .. " ";
		end
	
		if (dao.guild ~= nil) then
			result = result .. "<" .. dao.guild .. "> ";
		end

	end

	local playerkos = VanasKoS:IsOnList("PLAYERKOS", name);
	local nicelist = VanasKoS:IsOnList("NICELIST", name);
	local hatelist = VanasKoS:IsOnList("HATELIST", name);
	local guildkos = nil;
	if (showDetails and dao.guild ~= nil) then
		 guildkos = VanasKoS:IsOnList("GUILDKOS", dao.guild);
	end

	local reason = nil;
	if (playerkos ~= nil) then
		reason = playerkos;
	elseif (nicelist ~= nil) then
		reason = nicelist;
	elseif (hatelist ~= nil) then
		reason = hatelist;
	elseif (guildkos ~= nil) then
		reason = guildkos;
	end

	if (reason ~= nil) then
		result = result .. "(" .. reason .. ") ";
	end

	if (result == "") then
		result = L["No Information Available"];
	end

	return result;

end

